;/////////////////////////////////////////////////////////////;
;                                                             ;
;                     SimpleDX11 Constants                    ;
;                                                             ;
;                                                             ;
;                   (c) 2012 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////;

  
;- DXGI_USAGE
  #DXGI_CPU_ACCESS_NONE             = 0 
  #DXGI_CPU_ACCESS_DYNAMIC          = 1
  #DXGI_CPU_ACCESS_READ_WRITE       = 2
  #DXGI_CPU_ACCESS_SCRATCH          = 3
  #DXGI_CPU_ACCESS_FIELD            = 15
  #DXGI_USAGE_SHADER_INPUT          = ( 1 << (0 + 4) )
  #DXGI_USAGE_SHADER_INPUT          = ( 1 << (0 + 4) )
  #DXGI_USAGE_RENDER_TARGET_OUTPUT  = ( 1 << (1 + 4) )
  #DXGI_USAGE_BACK_BUFFER           = ( 1 << (2 + 4) )
  #DXGI_USAGE_SHARED                = ( 1 << (3 + 4) )
  #DXGI_USAGE_READ_ONLY             = ( 1 << (4 + 4) )
  #DXGI_USAGE_DISCARD_ON_PRESENT    = ( 1 << (5 + 4) )
  #DXGI_USAGE_UNORDERED_ACCESS      = ( 1 << (6 + 4) )


;- DXGI_FORMAT
  #DXGI_FORMAT_UNKNOWN                      = 0
  #DXGI_FORMAT_R32G32B32A32_TYPELESS        = 1
  #DXGI_FORMAT_R32G32B32A32_FLOAT           = 2
  #DXGI_FORMAT_R32G32B32A32_UINT            = 3
  #DXGI_FORMAT_R32G32B32A32_SINT            = 4
  #DXGI_FORMAT_R32G32B32_TYPELESS           = 5
  #DXGI_FORMAT_R32G32B32_FLOAT              = 6
  #DXGI_FORMAT_R32G32B32_UINT               = 7
  #DXGI_FORMAT_R32G32B32_SINT               = 8
  #DXGI_FORMAT_R16G16B16A16_TYPELESS        = 9
  #DXGI_FORMAT_R16G16B16A16_FLOAT           = 10
  #DXGI_FORMAT_R16G16B16A16_UNORM           = 11
  #DXGI_FORMAT_R16G16B16A16_UINT            = 12
  #DXGI_FORMAT_R16G16B16A16_SNORM           = 13
  #DXGI_FORMAT_R16G16B16A16_SINT            = 14
  #DXGI_FORMAT_R32G32_TYPELESS              = 15
  #DXGI_FORMAT_R32G32_FLOAT                 = 16
  #DXGI_FORMAT_R32G32_UINT                  = 17
  #DXGI_FORMAT_R32G32_SINT                  = 18
  #DXGI_FORMAT_R32G8X24_TYPELESS            = 19
  #DXGI_FORMAT_D32_FLOAT_S8X24_UINT         = 20
  #DXGI_FORMAT_R32_FLOAT_X8X24_TYPELESS     = 21
  #DXGI_FORMAT_X32_TYPELESS_G8X24_UINT      = 22
  #DXGI_FORMAT_R10G10B10A2_TYPELESS         = 23
  #DXGI_FORMAT_R10G10B10A2_UNORM            = 24
  #DXGI_FORMAT_R10G10B10A2_UINT             = 25
  #DXGI_FORMAT_R11G11B10_FLOAT              = 26
  #DXGI_FORMAT_R8G8B8A8_TYPELESS            = 27
  #DXGI_FORMAT_R8G8B8A8_UNORM               = 28
  #DXGI_FORMAT_R8G8B8A8_UNORM_SRGB          = 29
  #DXGI_FORMAT_R8G8B8A8_UINT                = 30
  #DXGI_FORMAT_R8G8B8A8_SNORM               = 31
  #DXGI_FORMAT_R8G8B8A8_SINT                = 32
  #DXGI_FORMAT_R16G16_TYPELESS              = 33
  #DXGI_FORMAT_R16G16_FLOAT                 = 34
  #DXGI_FORMAT_R16G16_UNORM                 = 35
  #DXGI_FORMAT_R16G16_UINT                  = 36
  #DXGI_FORMAT_R16G16_SNORM                 = 37
  #DXGI_FORMAT_R16G16_SINT                  = 38
  #DXGI_FORMAT_R32_TYPELESS                 = 39
  #DXGI_FORMAT_D32_FLOAT                    = 40
  #DXGI_FORMAT_R32_FLOAT                    = 41
  #DXGI_FORMAT_R32_UINT                     = 42
  #DXGI_FORMAT_R32_SINT                     = 43
  #DXGI_FORMAT_R24G8_TYPELESS               = 44
  #DXGI_FORMAT_D24_UNORM_S8_UINT            = 45
  #DXGI_FORMAT_R24_UNORM_X8_TYPELESS        = 46
  #DXGI_FORMAT_X24_TYPELESS_G8_UINT         = 47
  #DXGI_FORMAT_R8G8_TYPELESS                = 48
  #DXGI_FORMAT_R8G8_UNORM                   = 49
  #DXGI_FORMAT_R8G8_UINT                    = 50
  #DXGI_FORMAT_R8G8_SNORM                   = 51
  #DXGI_FORMAT_R8G8_SINT                    = 52
  #DXGI_FORMAT_R16_TYPELESS                 = 53
  #DXGI_FORMAT_R16_FLOAT                    = 54
  #DXGI_FORMAT_D16_UNORM                    = 55
  #DXGI_FORMAT_R16_UNORM                    = 56
  #DXGI_FORMAT_R16_UINT                     = 57
  #DXGI_FORMAT_R16_SNORM                    = 58
  #DXGI_FORMAT_R16_SINT                     = 59
  #DXGI_FORMAT_R8_TYPELESS                  = 60
  #DXGI_FORMAT_R8_UNORM                     = 61
  #DXGI_FORMAT_R8_UINT                      = 62
  #DXGI_FORMAT_R8_SNORM                     = 63
  #DXGI_FORMAT_R8_SINT                      = 64
  #DXGI_FORMAT_A8_UNORM                     = 65
  #DXGI_FORMAT_R1_UNORM                     = 66
  #DXGI_FORMAT_R9G9B9E5_SHAREDEXP           = 67
  #DXGI_FORMAT_R8G8_B8G8_UNORM              = 68
  #DXGI_FORMAT_G8R8_G8B8_UNORM              = 69
  #DXGI_FORMAT_BC1_TYPELESS                 = 70
  #DXGI_FORMAT_BC1_UNORM                    = 71
  #DXGI_FORMAT_BC1_UNORM_SRGB               = 72
  #DXGI_FORMAT_BC2_TYPELESS                 = 73
  #DXGI_FORMAT_BC2_UNORM                    = 74
  #DXGI_FORMAT_BC2_UNORM_SRGB               = 75
  #DXGI_FORMAT_BC3_TYPELESS                 = 76
  #DXGI_FORMAT_BC3_UNORM                    = 77
  #DXGI_FORMAT_BC3_UNORM_SRGB               = 78
  #DXGI_FORMAT_BC4_TYPELESS                 = 79
  #DXGI_FORMAT_BC4_UNORM                    = 80
  #DXGI_FORMAT_BC4_SNORM                    = 81
  #DXGI_FORMAT_BC5_TYPELESS                 = 82
  #DXGI_FORMAT_BC5_UNORM                    = 83
  #DXGI_FORMAT_BC5_SNORM                    = 84
  #DXGI_FORMAT_B5G6R5_UNORM                 = 85
  #DXGI_FORMAT_B5G5R5A1_UNORM               = 86
  #DXGI_FORMAT_B8G8R8A8_UNORM               = 87
  #DXGI_FORMAT_B8G8R8X8_UNORM               = 88
  #DXGI_FORMAT_R10G10B10_XR_BIAS_A2_UNORM   = 89
  #DXGI_FORMAT_B8G8R8A8_TYPELESS            = 90
  #DXGI_FORMAT_B8G8R8A8_UNORM_SRGB          = 91
  #DXGI_FORMAT_B8G8R8X8_TYPELESS            = 92
  #DXGI_FORMAT_B8G8R8X8_UNORM_SRGB          = 93
  #DXGI_FORMAT_BC6H_TYPELESS                = 94
  #DXGI_FORMAT_BC6H_UF16                    = 95
  #DXGI_FORMAT_BC6H_SF16                    = 96
  #DXGI_FORMAT_BC7_TYPELESS                 = 97
  #DXGI_FORMAT_BC7_UNORM                    = 98
  #DXGI_FORMAT_BC7_UNORM_SRGB               = 99
  #DXGI_FORMAT_AYUV                         = 100
  #DXGI_FORMAT_Y410                         = 101
  #DXGI_FORMAT_Y416                         = 102
  #DXGI_FORMAT_NV12                         = 103
  #DXGI_FORMAT_P010                         = 104
  #DXGI_FORMAT_P016                         = 105
  #DXGI_FORMAT_420_OPAQUE                   = 106
  #DXGI_FORMAT_YUY2                         = 107
  #DXGI_FORMAT_Y210                         = 108
  #DXGI_FORMAT_Y216                         = 109
  #DXGI_FORMAT_NV11                         = 110
  #DXGI_FORMAT_AI44                         = 111
  #DXGI_FORMAT_IA44                         = 112
  #DXGI_FORMAT_P8                           = 113
  #DXGI_FORMAT_A8P8                         = 114
  #DXGI_FORMAT_B4G4R4A4_UNORM               = 115
  #DXGI_FORMAT_FORCE_UINT                   = $ffffffff 
 
  
;- DXGI_MODE_SCANLINE_ORDER
  #DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED         = 0
  #DXGI_MODE_SCANLINE_ORDER_PROGRESSIVE         = 1
  #DXGI_MODE_SCANLINE_ORDER_UPPER_FIELD_FIRST   = 2
  #DXGI_MODE_SCANLINE_ORDER_LOWER_FIELD_FIRST   = 3   
    
  
;- DXGI_MODE_SCALING
  #DXGI_MODE_SCALING_UNSPECIFIED   = 0
  #DXGI_MODE_SCALING_CENTERED      = 1
  #DXGI_MODE_SCALING_STRETCHED     = 2   
  
;- DXGI_SWAP_EFFECT 
  #DXGI_SWAP_EFFECT_DISCARD           = 0
  #DXGI_SWAP_EFFECT_SEQUENTIAL        = 1
  #DXGI_SWAP_EFFECT_FLIP_SEQUENTIAL   = 3

;- DXGI_SWAP_CHAIN_FLAG 
  #DXGI_SWAP_CHAIN_FLAG_NONPREROTATED                    = 1
  #DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH                = 2
  #DXGI_SWAP_CHAIN_FLAG_GDI_COMPATIBLE                   = 4
  #DXGI_SWAP_CHAIN_FLAG_RESTRICTED_CONTENT               = 8
  #DXGI_SWAP_CHAIN_FLAG_RESTRICT_SHARED_RESOURCE_DRIVER  = 16
  #DXGI_SWAP_CHAIN_FLAG_DISPLAY_ONLY                     = 32
  
;- D3D10_CREATE_DEVICE_FLAG  
  #D3D10_CREATE_DEVICE_SINGLETHREADED                                 = $1
  #D3D10_CREATE_DEVICE_DEBUG                                          = $2
  #D3D10_CREATE_DEVICE_SWITCH_TO_REF                                  = $4
  #D3D10_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS       = $8
  #D3D10_CREATE_DEVICE_ALLOW_NULL_FROM_MAP                            = $10
  #D3D10_CREATE_DEVICE_BGRA_SUPPORT                                   = $20
  #D3D10_CREATE_DEVICE_PREVENT_ALTERING_LAYER_SETTINGS_FROM_REGISTRY  = $80
  #D3D10_CREATE_DEVICE_STRICT_VALIDATION                              = $200
  #D3D10_CREATE_DEVICE_DEBUGGABLE                                     = $400

;- D3D11_CREATE_DEVICE_FLAG  
  #D3D11_CREATE_DEVICE_SINGLETHREADED                                 = $1
  #D3D11_CREATE_DEVICE_DEBUG                                          = $2
  #D3D11_CREATE_DEVICE_SWITCH_TO_REF                                  = $4
  #D3D11_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS       = $8
  #D3D11_CREATE_DEVICE_BGRA_SUPPORT                                   = $20
  #D3D11_CREATE_DEVICE_DEBUGGABLE                                     = $40
  #D3D11_CREATE_DEVICE_PREVENT_ALTERING_LAYER_SETTINGS_FROM_REGISTRY  = $80
  #D3D11_CREATE_DEVICE_DISABLE_GPU_TIMEOUT                            = $100
  #D3D11_CREATE_DEVICE_VIDEO_SUPPORT                                  = $800 
  

  
  
;- #D3DCOMPILE FLAGS   
  #D3DCOMPILE_AVOID_FLOW_CONTROL                = (1 << 9)
  #D3DCOMPILE_DEBUG                             = (1 << 0)
  #D3DCOMPILE_ENABLE_BACKWARDS_COMPATIBILITY    = (1 << 12)
  #D3DCOMPILE_ENABLE_STRICTNESS                 = (1 << 11)
  #D3DCOMPILE_FORCE_PS_SOFTWARE_NO_OPT    = (1 << 7)
  #D3DCOMPILE_FORCE_VS_SOFTWARE_NO_OPT    = (1 << 6)
  #D3DCOMPILE_IEEE_STRICTNESS             = (1 << 13)
  #D3DCOMPILE_NO_PRESHADER                = (1 << 8)
  #D3DCOMPILE_OPTIMIZATION_LEVEL0         = (1 << 14)
  #D3DCOMPILE_OPTIMIZATION_LEVEL1         = 0
  #D3DCOMPILE_OPTIMIZATION_LEVEL2         = ((1 << 14) | (1 << 15))
  #D3DCOMPILE_OPTIMIZATION_LEVEL3         = (1 << 15)
  #D3DCOMPILE_PACK_MATRIX_COLUMN_MAJOR    = (1 << 4)
  #D3DCOMPILE_PACK_MATRIX_ROW_MAJOR       = (1 << 3)
  #D3DCOMPILE_PARTIAL_PRECISION           = (1 << 5)
  #D3DCOMPILE_PREFER_FLOW_CONTROL         = (1 << 10)
  #D3DCOMPILE_SKIP_OPTIMIZATION           = (1 << 2)
  #D3DCOMPILE_SKIP_VALIDATION             = (1 << 1)
  #D3DCOMPILE_WARNINGS_ARE_ERRORS         = (1 << 18)  
  
;- D3D_FEATURE_LEVEL
  #D3D_FEATURE_LEVEL_9_1    = $9100
  #D3D_FEATURE_LEVEL_9_2    = $9200
  #D3D_FEATURE_LEVEL_9_3    = $9300
  #D3D_FEATURE_LEVEL_10_0   = $a000
  #D3D_FEATURE_LEVEL_10_1   = $a100
  #D3D_FEATURE_LEVEL_11_0   = $b000
  #D3D_FEATURE_LEVEL_11_1   = $b100   
  
  
  
;- D3D11_FEATURE
  #D3D11_FEATURE_THREADING                      = 0
  #D3D11_FEATURE_DOUBLES                        = ( #D3D11_FEATURE_THREADING + 1 )
  #D3D11_FEATURE_FORMAT_SUPPORT                 = ( #D3D11_FEATURE_DOUBLES + 1 )
  #D3D11_FEATURE_FORMAT_SUPPORT2                = ( #D3D11_FEATURE_FORMAT_SUPPORT + 1 )
  #D3D11_FEATURE_D3D10_X_HARDWARE_OPTIONS       = ( #D3D11_FEATURE_FORMAT_SUPPORT2 + 1 )
  #D3D11_FEATURE_D3D11_OPTIONS                  = ( #D3D11_FEATURE_D3D10_X_HARDWARE_OPTIONS + 1 )
  #D3D11_FEATURE_ARCHITECTURE_INFO              = ( #D3D11_FEATURE_D3D11_OPTIONS + 1 )
  #D3D11_FEATURE_D3D9_OPTIONS                   = ( #D3D11_FEATURE_ARCHITECTURE_INFO + 1 )
  #D3D11_FEATURE_SHADER_MIN_PRECISION_SUPPORT   = ( #D3D11_FEATURE_D3D9_OPTIONS + 1 )
  #D3D11_FEATURE_D3D9_SHADOW_SUPPORT            = ( #D3D11_FEATURE_SHADER_MIN_PRECISION_SUPPORT + 1 )   
  

;- D3D_DRIVER_TYPE
  #D3D_DRIVER_TYPE_UNKNOWN     = 0
  #D3D_DRIVER_TYPE_HARDWARE    = ( #D3D_DRIVER_TYPE_UNKNOWN + 1 )
  #D3D_DRIVER_TYPE_REFERENCE   = ( #D3D_DRIVER_TYPE_HARDWARE + 1 )
  #D3D_DRIVER_TYPE_NULL        = ( #D3D_DRIVER_TYPE_REFERENCE + 1 )
  #D3D_DRIVER_TYPE_SOFTWARE    = ( #D3D_DRIVER_TYPE_NULL + 1 )
  #D3D_DRIVER_TYPE_WARP        = ( #D3D_DRIVER_TYPE_SOFTWARE + 1 )     
  
  
;- D3D10_DEPTH_WRITE_MASK 
  #D3D10_DEPTH_WRITE_MASK_ZERO  = 0
  #D3D10_DEPTH_WRITE_MASK_ALL   = 1

 
  

;- SDK_VERSION 
  #D3D11_SDK_VERSION  = 7


;- D3D11_COUNTER
  #D3D11_COUNTER_DEVICE_DEPENDENT_0   = $40000000 


;-  D3D11_COUNTER_TYPE
  #D3D11_COUNTER_TYPE_FLOAT32   = 0
  #D3D11_COUNTER_TYPE_UINT16    = (#D3D11_COUNTER_TYPE_FLOAT32 + 1)
  #D3D11_COUNTER_TYPE_UINT32    = (#D3D11_COUNTER_TYPE_UINT16 + 1)
  #D3D11_COUNTER_TYPE_UINT64    = (#D3D11_COUNTER_TYPE_UINT32 + 1)    

  
;- D3D11_BLEND
  #D3D11_BLEND_ZERO               = 1
  #D3D11_BLEND_ONE                = 2
  #D3D11_BLEND_SRC_COLOR          = 3
  #D3D11_BLEND_INV_SRC_COLOR      = 4
  #D3D11_BLEND_SRC_ALPHA          = 5
  #D3D11_BLEND_INV_SRC_ALPHA      = 6
  #D3D11_BLEND_DEST_ALPHA         = 7
  #D3D11_BLEND_INV_DEST_ALPHA     = 8
  #D3D11_BLEND_DEST_COLOR         = 9
  #D3D11_BLEND_INV_DEST_COLOR     = 10
  #D3D11_BLEND_SRC_ALPHA_SAT      = 11
  #D3D11_BLEND_BLEND_FACTOR       = 14
  #D3D11_BLEND_INV_BLEND_FACTOR   = 15
  #D3D11_BLEND_SRC1_COLOR         = 16
  #D3D11_BLEND_INV_SRC1_COLOR     = 17
  #D3D11_BLEND_SRC1_ALPHA         = 18
  #D3D11_BLEND_INV_SRC1_ALPHA     = 19 

;- D3D11_BLEND_OP  
  #D3D11_BLEND_OP_ADD            = 1
  #D3D11_BLEND_OP_SUBTRACT       = 2
  #D3D11_BLEND_OP_REV_SUBTRACT   = 3
  #D3D11_BLEND_OP_MIN            = 4
  #D3D11_BLEND_OP_MAX            = 5

  
;- D3D11_INPUT_CLASSIFICATION 
  #D3D11_INPUT_PER_VERTEX_DATA     = 0
  #D3D11_INPUT_PER_INSTANCE_DATA   = 1 


;- D3DCOMPILE Constants
  #D3DCOMPILE_AVOID_FLOW_CONTROL              = (1 << 9)
  #D3DCOMPILE_DEBUG                           = (1 << 0)
  #D3DCOMPILE_ENABLE_BACKWARDS_COMPATIBILITY  = (1 << 12)
  #D3DCOMPILE_ENABLE_STRICTNESS               = (1 << 11)
  #D3DCOMPILE_FORCE_PS_SOFTWARE_NO_OPT        = (1 << 7)
  #D3DCOMPILE_FORCE_VS_SOFTWARE_NO_OPT        = (1 << 6)
  #D3DCOMPILE_IEEE_STRICTNESS                 = (1 << 13)
  #D3DCOMPILE_NO_PRESHADER                    = (1 << 8) 
  #D3DCOMPILE_OPTIMIZATION_LEVEL0             = (1 << 14)
  #D3DCOMPILE_OPTIMIZATION_LEVEL1             =  0
  #D3DCOMPILE_OPTIMIZATION_LEVEL2             = ((1 << 14) | (1 << 15))
  #D3DCOMPILE_OPTIMIZATION_LEVEL3             = (1 << 15)
  #D3DCOMPILE_PACK_MATRIX_COLUMN_MAJOR        = (1 << 4)
  #D3DCOMPILE_PACK_MATRIX_ROW_MAJOR           = (1 << 3)
  #D3DCOMPILE_PARTIAL_PRECISION               = (1 << 5)
  #D3DCOMPILE_PREFER_FLOW_CONTROL             = (1 << 10)
  #D3DCOMPILE_SKIP_OPTIMIZATION               = (1 << 2)
  #D3DCOMPILE_SKIP_VALIDATION                 = (1 << 1)
  #D3DCOMPILE_WARNINGS_ARE_ERRORS             = (1 << 18)




;- D3D11_USAGE 
  #D3D11_USAGE_DEFAULT     = 0
  #D3D11_USAGE_IMMUTABLE   = 1
  #D3D11_USAGE_DYNAMIC     = 2
  #D3D11_USAGE_STAGING     = 3 





;- D3D11_BIND_FLAG  
  #D3D11_BIND_VERTEX_BUFFER      = $1
  #D3D11_BIND_INDEX_BUFFER       = $2
  #D3D11_BIND_CONSTANT_BUFFER    = $4
  #D3D11_BIND_SHADER_RESOURCE    = $8
  #D3D11_BIND_STREAM_OUTPUT      = $10
  #D3D11_BIND_RENDER_TARGET      = $20
  #D3D11_BIND_DEPTH_STENCIL      = $40
  #D3D11_BIND_UNORDERED_ACCESS   = $80
  #D3D11_BIND_DECODER            = $200
  #D3D11_BIND_VIDEO_ENCODER      = $400
  
  
;- D3D_PRIMITIVE_TOPOLOGY 
  #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED                      = 0
  #D3D_PRIMITIVE_TOPOLOGY_POINTLIST                      = 1
  #D3D_PRIMITIVE_TOPOLOGY_LINELIST                       = 2
  #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP                      = 3
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST                   = 4
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP                  = 5
  #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                   = 10
  #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ                  = 11
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ               = 12
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ              = 13
  #D3D_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST      = 33
  #D3D_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST      = 34
  #D3D_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST      = 35
  #D3D_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST      = 36
  #D3D_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST      = 37
  #D3D_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST      = 38
  #D3D_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST      = 39
  #D3D_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST      = 40
  #D3D_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST      = 41
  #D3D_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST     = 42
  #D3D_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST     = 43
  #D3D_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST     = 44
  #D3D_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST     = 45
  #D3D_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST     = 46
  #D3D_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST     = 47
  #D3D_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST     = 48
  #D3D_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST     = 49
  #D3D_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST     = 50
  #D3D_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST     = 51
  #D3D_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST     = 52
  #D3D_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST     = 53
  #D3D_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST     = 54
  #D3D_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST     = 55
  #D3D_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST     = 56
  #D3D_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST     = 57
  #D3D_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST     = 58
  #D3D_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST     = 59
  #D3D_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST     = 60
  #D3D_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST     = 61
  #D3D_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST     = 62
  #D3D_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST     = 63
  #D3D_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST     = 64
  #D3D10_PRIMITIVE_TOPOLOGY_UNDEFINED                    = #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED
  #D3D10_PRIMITIVE_TOPOLOGY_POINTLIST                    = #D3D_PRIMITIVE_TOPOLOGY_POINTLIST
  #D3D10_PRIMITIVE_TOPOLOGY_LINELIST                     = #D3D_PRIMITIVE_TOPOLOGY_LINELIST
  #D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP                    = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST                 = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP                = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP
  #D3D10_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                 = #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ                = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ             = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ            = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_UNDEFINED                    = #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED
  #D3D11_PRIMITIVE_TOPOLOGY_POINTLIST                    = #D3D_PRIMITIVE_TOPOLOGY_POINTLIST
  #D3D11_PRIMITIVE_TOPOLOGY_LINELIST                     = #D3D_PRIMITIVE_TOPOLOGY_LINELIST
  #D3D11_PRIMITIVE_TOPOLOGY_LINESTRIP                    = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST                 = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP                = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP
  #D3D11_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                 = #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ                = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ             = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ            = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST    = #D3D_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST 



;- D3D11_MAP  
  #D3D11_MAP_READ                 = 1
  #D3D11_MAP_WRITE                = 2
  #D3D11_MAP_READ_WRITE           = 3
  #D3D11_MAP_WRITE_DISCARD        = 4
  #D3D11_MAP_WRITE_NO_OVERWRITE   = 5 
  
;- D3D11_CPU_ACCESS_FLAG 
  #D3D11_CPU_ACCESS_WRITE   = $10000
  #D3D11_CPU_ACCESS_READ    = $20000  
  
;- D3D11_DEPTH_WRITE_MASK 
  #D3D11_DEPTH_WRITE_MASK_ZERO   = 0
  #D3D11_DEPTH_WRITE_MASK_ALL    = 1 
  
;- D3D11_COMPARISON_FUNC 
  #D3D11_COMPARISON_NEVER           = 1
  #D3D11_COMPARISON_LESS            = 2
  #D3D11_COMPARISON_EQUAL           = 3
  #D3D11_COMPARISON_LESS_EQUAL      = 4
  #D3D11_COMPARISON_GREATER         = 5
  #D3D11_COMPARISON_NOT_EQUAL       = 6
  #D3D11_COMPARISON_GREATER_EQUAL   = 7
  #D3D11_COMPARISON_ALWAYS          = 8 
  
;- D3D11_STENCIL_OP 
  #D3D11_STENCIL_OP_KEEP       = 1
  #D3D11_STENCIL_OP_ZERO       = 2
  #D3D11_STENCIL_OP_REPLACE    = 3
  #D3D11_STENCIL_OP_INCR_SAT   = 4
  #D3D11_STENCIL_OP_DECR_SAT   = 5
  #D3D11_STENCIL_OP_INVERT     = 6
  #D3D11_STENCIL_OP_INCR       = 7
  #D3D11_STENCIL_OP_DECR       = 8  
  
  
  
  
;- D3D11_COMPARISON_FUNC 
  #D3D11_COMPARISON_NEVER           = 1
  #D3D11_COMPARISON_LESS            = 2
  #D3D11_COMPARISON_EQUAL           = 3
  #D3D11_COMPARISON_LESS_EQUAL      = 4
  #D3D11_COMPARISON_GREATER         = 5
  #D3D11_COMPARISON_NOT_EQUAL       = 6
  #D3D11_COMPARISON_GREATER_EQUAL   = 7
  #D3D11_COMPARISON_ALWAYS          = 8 

  
;- D3D11_DSV_DIMENSION 
  #D3D11_DSV_DIMENSION_UNKNOWN            = 0
  #D3D11_DSV_DIMENSION_TEXTURE1D          = 1
  #D3D11_DSV_DIMENSION_TEXTURE1DARRAY     = 2
  #D3D11_DSV_DIMENSION_TEXTURE2D          = 3
  #D3D11_DSV_DIMENSION_TEXTURE2DARRAY     = 4
  #D3D11_DSV_DIMENSION_TEXTURE2DMS        = 5
  #D3D11_DSV_DIMENSION_TEXTURE2DMSARRAY   = 6 

  
  
;- D3D11_FILL_MODE 
  #D3D11_FILL_WIREFRAME   = 2
  #D3D11_FILL_SOLID       = 3 

  
;- D3D11_CULL_MODE 
  #D3D11_CULL_NONE    = 1
  #D3D11_CULL_FRONT   = 2
  #D3D11_CULL_BACK    = 3   
  
;- D3D11_CLEAR_FLAG 
  #D3D11_CLEAR_DEPTH     = $1
  #D3D11_CLEAR_STENCIL   = $2

  
  #D3D11_APPEND_ALIGNED_ELEMENT = $ffffffff
  
;- D3D_PRIMITIVE_TOPOLOGY 
  #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED                     = 0
  #D3D_PRIMITIVE_TOPOLOGY_POINTLIST                     = 1
  #D3D_PRIMITIVE_TOPOLOGY_LINELIST                      = 2
  #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP                     = 3
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST                  = 4
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP                 = 5
  #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                  = 10
  #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ                 = 11
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ              = 12
  #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ             = 13
  #D3D_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST     = 33
  #D3D_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST     = 34
  #D3D_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST     = 35
  #D3D_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST     = 36
  #D3D_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST     = 37
  #D3D_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST     = 38
  #D3D_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST     = 39
  #D3D_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST     = 40
  #D3D_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST     = 41
  #D3D_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST    = 42
  #D3D_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST    = 43
  #D3D_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST    = 44
  #D3D_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST    = 45
  #D3D_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST    = 46
  #D3D_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST    = 47
  #D3D_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST    = 48
  #D3D_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST    = 49
  #D3D_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST    = 50
  #D3D_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST    = 51
  #D3D_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST    = 52
  #D3D_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST    = 53
  #D3D_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST    = 54
  #D3D_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST    = 55
  #D3D_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST    = 56
  #D3D_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST    = 57
  #D3D_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST    = 58
  #D3D_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST    = 59
  #D3D_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST    = 60
  #D3D_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST    = 61
  #D3D_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST    = 62
  #D3D_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST    = 63
  #D3D_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST    = 64
  #D3D10_PRIMITIVE_TOPOLOGY_UNDEFINED                   = #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED
  #D3D10_PRIMITIVE_TOPOLOGY_POINTLIST                   = #D3D_PRIMITIVE_TOPOLOGY_POINTLIST
  #D3D10_PRIMITIVE_TOPOLOGY_LINELIST                    = #D3D_PRIMITIVE_TOPOLOGY_LINELIST
  #D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP                   = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST                = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP               = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP
  #D3D10_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                = #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ               = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ            = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ
  #D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ           = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_UNDEFINED                   = #D3D_PRIMITIVE_TOPOLOGY_UNDEFINED
  #D3D11_PRIMITIVE_TOPOLOGY_POINTLIST                   = #D3D_PRIMITIVE_TOPOLOGY_POINTLIST
  #D3D11_PRIMITIVE_TOPOLOGY_LINELIST                    = #D3D_PRIMITIVE_TOPOLOGY_LINELIST
  #D3D11_PRIMITIVE_TOPOLOGY_LINESTRIP                   = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST                = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP               = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP
  #D3D11_PRIMITIVE_TOPOLOGY_LINELIST_ADJ                = #D3D_PRIMITIVE_TOPOLOGY_LINELIST_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ               = #D3D_PRIMITIVE_TOPOLOGY_LINESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ            = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLELIST_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ           = #D3D_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP_ADJ
  #D3D11_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_1_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_2_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_3_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_4_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_5_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_6_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_7_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_8_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST   = #D3D_PRIMITIVE_TOPOLOGY_9_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_10_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_11_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_12_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_13_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_14_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_15_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_16_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_17_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_18_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_19_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_20_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_21_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_22_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_23_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_24_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_25_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_26_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_27_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_28_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_29_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_30_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_31_CONTROL_POINT_PATCHLIST
  #D3D11_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST  = #D3D_PRIMITIVE_TOPOLOGY_32_CONTROL_POINT_PATCHLIST
  
  
  
  ;- #D3D_PRIMITIVE 
  #D3D_PRIMITIVE_UNDEFINED                 = 0
  #D3D_PRIMITIVE_POINT                     = 1
  #D3D_PRIMITIVE_LINE                      = 2
  #D3D_PRIMITIVE_TRIANGLE                  = 3
  #D3D_PRIMITIVE_LINE_ADJ                  = 6
  #D3D_PRIMITIVE_TRIANGLE_ADJ              = 7
  #D3D_PRIMITIVE_1_CONTROL_POINT_PATCH     = 8
  #D3D_PRIMITIVE_2_CONTROL_POINT_PATCH     = 9
  #D3D_PRIMITIVE_3_CONTROL_POINT_PATCH     = 10
  #D3D_PRIMITIVE_4_CONTROL_POINT_PATCH     = 11
  #D3D_PRIMITIVE_5_CONTROL_POINT_PATCH     = 12
  #D3D_PRIMITIVE_6_CONTROL_POINT_PATCH     = 13
  #D3D_PRIMITIVE_7_CONTROL_POINT_PATCH     = 14
  #D3D_PRIMITIVE_8_CONTROL_POINT_PATCH     = 15
  #D3D_PRIMITIVE_9_CONTROL_POINT_PATCH     = 16
  #D3D_PRIMITIVE_10_CONTROL_POINT_PATCH    = 17
  #D3D_PRIMITIVE_11_CONTROL_POINT_PATCH    = 18
  #D3D_PRIMITIVE_12_CONTROL_POINT_PATCH    = 19
  #D3D_PRIMITIVE_13_CONTROL_POINT_PATCH    = 20
  #D3D_PRIMITIVE_14_CONTROL_POINT_PATCH    = 21
  #D3D_PRIMITIVE_15_CONTROL_POINT_PATCH    = 22
  #D3D_PRIMITIVE_16_CONTROL_POINT_PATCH    = 23
  #D3D_PRIMITIVE_17_CONTROL_POINT_PATCH    = 24
  #D3D_PRIMITIVE_18_CONTROL_POINT_PATCH    = 25
  #D3D_PRIMITIVE_19_CONTROL_POINT_PATCH    = 26
  #D3D_PRIMITIVE_20_CONTROL_POINT_PATCH    = 28
  #D3D_PRIMITIVE_21_CONTROL_POINT_PATCH    = 29
  #D3D_PRIMITIVE_22_CONTROL_POINT_PATCH    = 30
  #D3D_PRIMITIVE_23_CONTROL_POINT_PATCH    = 31
  #D3D_PRIMITIVE_24_CONTROL_POINT_PATCH    = 32
  #D3D_PRIMITIVE_25_CONTROL_POINT_PATCH    = 33
  #D3D_PRIMITIVE_26_CONTROL_POINT_PATCH    = 34
  #D3D_PRIMITIVE_27_CONTROL_POINT_PATCH    = 35
  #D3D_PRIMITIVE_28_CONTROL_POINT_PATCH    = 36
  #D3D_PRIMITIVE_29_CONTROL_POINT_PATCH    = 37
  #D3D_PRIMITIVE_30_CONTROL_POINT_PATCH    = 38
  #D3D_PRIMITIVE_31_CONTROL_POINT_PATCH    = 39
  #D3D_PRIMITIVE_32_CONTROL_POINT_PATCH    = 40
  #D3D10_PRIMITIVE_UNDEFINED               = #D3D_PRIMITIVE_UNDEFINED
  #D3D10_PRIMITIVE_POINT                   = #D3D_PRIMITIVE_POINT
  #D3D10_PRIMITIVE_LINE                    = #D3D_PRIMITIVE_LINE
  #D3D10_PRIMITIVE_TRIANGLE                = #D3D_PRIMITIVE_TRIANGLE
  #D3D10_PRIMITIVE_LINE_ADJ                = #D3D_PRIMITIVE_LINE_ADJ
  #D3D10_PRIMITIVE_TRIANGLE_ADJ            = #D3D_PRIMITIVE_TRIANGLE_ADJ
  #D3D11_PRIMITIVE_UNDEFINED               = #D3D_PRIMITIVE_UNDEFINED
  #D3D11_PRIMITIVE_POINT                   = #D3D_PRIMITIVE_POINT
  #D3D11_PRIMITIVE_LINE                    = #D3D_PRIMITIVE_LINE
  #D3D11_PRIMITIVE_TRIANGLE                = #D3D_PRIMITIVE_TRIANGLE
  #D3D11_PRIMITIVE_LINE_ADJ                = #D3D_PRIMITIVE_LINE_ADJ
  #D3D11_PRIMITIVE_TRIANGLE_ADJ            = #D3D_PRIMITIVE_TRIANGLE_ADJ
  #D3D11_PRIMITIVE_1_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_1_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_2_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_2_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_3_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_3_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_4_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_4_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_5_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_5_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_6_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_6_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_7_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_7_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_8_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_8_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_9_CONTROL_POINT_PATCH   = #D3D_PRIMITIVE_9_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_10_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_10_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_11_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_11_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_12_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_12_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_13_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_13_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_14_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_14_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_15_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_15_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_16_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_16_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_17_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_17_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_18_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_18_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_19_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_19_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_20_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_20_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_21_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_21_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_22_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_22_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_23_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_23_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_24_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_24_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_25_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_25_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_26_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_26_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_27_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_27_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_28_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_28_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_29_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_29_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_30_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_30_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_31_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_31_CONTROL_POINT_PATCH
  #D3D11_PRIMITIVE_32_CONTROL_POINT_PATCH  = #D3D_PRIMITIVE_32_CONTROL_POINT_PATCH


;- D3D_TESSELLATOR_OUTPUT_PRIMITIVE 
  #D3D_TESSELLATOR_OUTPUT_UNDEFINED       = 0
  #D3D_TESSELLATOR_OUTPUT_POINT           = 1
  #D3D_TESSELLATOR_OUTPUT_LINE            = 2
  #D3D_TESSELLATOR_OUTPUT_TRIANGLE_CW     = 3
  #D3D_TESSELLATOR_OUTPUT_TRIANGLE_CCW    = 4
  #D3D11_TESSELLATOR_OUTPUT_UNDEFINED     = #D3D_TESSELLATOR_OUTPUT_UNDEFINED
  #D3D11_TESSELLATOR_OUTPUT_POINT         = #D3D_TESSELLATOR_OUTPUT_POINT
  #D3D11_TESSELLATOR_OUTPUT_LINE          = #D3D_TESSELLATOR_OUTPUT_LINE
  #D3D11_TESSELLATOR_OUTPUT_TRIANGLE_CW   = #D3D_TESSELLATOR_OUTPUT_TRIANGLE_CW
  #D3D11_TESSELLATOR_OUTPUT_TRIANGLE_CCW  = #D3D_TESSELLATOR_OUTPUT_TRIANGLE_CCW
  
;- D3D_TESSELLATOR_PARTITIONING 
  #D3D_TESSELLATOR_PARTITIONING_UNDEFINED          = 0
  #D3D_TESSELLATOR_PARTITIONING_INTEGER            = 1
  #D3D_TESSELLATOR_PARTITIONING_POW2               = 2
  #D3D_TESSELLATOR_PARTITIONING_FRACTIONAL_ODD     = 3
  #D3D_TESSELLATOR_PARTITIONING_FRACTIONAL_EVEN    = 4
  #D3D11_TESSELLATOR_PARTITIONING_UNDEFINED        = #D3D_TESSELLATOR_PARTITIONING_UNDEFINED
  #D3D11_TESSELLATOR_PARTITIONING_INTEGER          = #D3D_TESSELLATOR_PARTITIONING_INTEGER
  #D3D11_TESSELLATOR_PARTITIONING_POW2             = #D3D_TESSELLATOR_PARTITIONING_POW2
  #D3D11_TESSELLATOR_PARTITIONING_FRACTIONAL_ODD   = #D3D_TESSELLATOR_PARTITIONING_FRACTIONAL_ODD
  #D3D11_TESSELLATOR_PARTITIONING_FRACTIONAL_EVEN  = #D3D_TESSELLATOR_PARTITIONING_FRACTIONAL_EVEN

;- D3D_TESSELLATOR_DOMAIN 
  #D3D_TESSELLATOR_DOMAIN_UNDEFINED    = 0
  #D3D_TESSELLATOR_DOMAIN_ISOLINE      = 1
  #D3D_TESSELLATOR_DOMAIN_TRI          = 2
  #D3D_TESSELLATOR_DOMAIN_QUAD         = 3
  #D3D11_TESSELLATOR_DOMAIN_UNDEFINED  = #D3D_TESSELLATOR_DOMAIN_UNDEFINED
  #D3D11_TESSELLATOR_DOMAIN_ISOLINE    = #D3D_TESSELLATOR_DOMAIN_ISOLINE
  #D3D11_TESSELLATOR_DOMAIN_TRI        = #D3D_TESSELLATOR_DOMAIN_TRI
  #D3D11_TESSELLATOR_DOMAIN_QUAD       = #D3D_TESSELLATOR_DOMAIN_QUAD
  
;- #D3D_NAME  
  #D3D_NAME_UNDEFINED                        = 0
  #D3D_NAME_POSITION                         = 1
  #D3D_NAME_CLIP_DISTANCE                    = 2
  #D3D_NAME_CULL_DISTANCE                    = 3
  #D3D_NAME_RENDER_TARGET_ARRAY_INDEX        = 4
  #D3D_NAME_VIEWPORT_ARRAY_INDEX             = 5
  #D3D_NAME_VERTEX_ID                        = 6
  #D3D_NAME_PRIMITIVE_ID                     = 7
  #D3D_NAME_INSTANCE_ID                      = 8
  #D3D_NAME_IS_FRONT_FACE                    = 9
  #D3D_NAME_SAMPLE_INDEX                     = 10
  #D3D_NAME_FINAL_QUAD_EDGE_TESSFACTOR       = 11
  #D3D_NAME_FINAL_QUAD_INSIDE_TESSFACTOR     = 12
  #D3D_NAME_FINAL_TRI_EDGE_TESSFACTOR        = 13
  #D3D_NAME_FINAL_TRI_INSIDE_TESSFACTOR      = 14
  #D3D_NAME_FINAL_LINE_DETAIL_TESSFACTOR     = 15
  #D3D_NAME_FINAL_LINE_DENSITY_TESSFACTOR    = 16
  #D3D_NAME_TARGET                           = 64
  #D3D_NAME_DEPTH                            = 65
  #D3D_NAME_COVERAGE                         = 66
  #D3D_NAME_DEPTH_GREATER_EQUAL              = 67
  #D3D_NAME_DEPTH_LESS_EQUAL                 = 68
  #D3D10_NAME_UNDEFINED                      = #D3D_NAME_UNDEFINED
  #D3D10_NAME_POSITION                       = #D3D_NAME_POSITION
  #D3D10_NAME_CLIP_DISTANCE                  = #D3D_NAME_CLIP_DISTANCE
  #D3D10_NAME_CULL_DISTANCE                  = #D3D_NAME_CULL_DISTANCE
  #D3D10_NAME_RENDER_TARGET_ARRAY_INDEX      = #D3D_NAME_RENDER_TARGET_ARRAY_INDEX
  #D3D10_NAME_VIEWPORT_ARRAY_INDEX           = #D3D_NAME_VIEWPORT_ARRAY_INDEX
  #D3D10_NAME_VERTEX_ID                      = #D3D_NAME_VERTEX_ID
  #D3D10_NAME_PRIMITIVE_ID                   = #D3D_NAME_PRIMITIVE_ID
  #D3D10_NAME_INSTANCE_ID                    = #D3D_NAME_INSTANCE_ID
  #D3D10_NAME_IS_FRONT_FACE                  = #D3D_NAME_IS_FRONT_FACE
  #D3D10_NAME_SAMPLE_INDEX                   = #D3D_NAME_SAMPLE_INDEX
  #D3D11_NAME_FINAL_QUAD_EDGE_TESSFACTOR     = #D3D_NAME_FINAL_QUAD_EDGE_TESSFACTOR
  #D3D11_NAME_FINAL_QUAD_INSIDE_TESSFACTOR   = #D3D_NAME_FINAL_QUAD_INSIDE_TESSFACTOR
  #D3D11_NAME_FINAL_TRI_EDGE_TESSFACTOR      = #D3D_NAME_FINAL_TRI_EDGE_TESSFACTOR
  #D3D11_NAME_FINAL_TRI_INSIDE_TESSFACTOR    = #D3D_NAME_FINAL_TRI_INSIDE_TESSFACTOR
  #D3D11_NAME_FINAL_LINE_DETAIL_TESSFACTOR   = #D3D_NAME_FINAL_LINE_DETAIL_TESSFACTOR
  #D3D11_NAME_FINAL_LINE_DENSITY_TESSFACTOR  = #D3D_NAME_FINAL_LINE_DENSITY_TESSFACTOR
  #D3D10_NAME_TARGET                         = #D3D_NAME_TARGET
  #D3D10_NAME_DEPTH                          = #D3D_NAME_DEPTH
  #D3D10_NAME_COVERAGE                       = #D3D_NAME_COVERAGE
  #D3D11_NAME_DEPTH_GREATER_EQUAL            = #D3D_NAME_DEPTH_GREATER_EQUAL
  #D3D11_NAME_DEPTH_LESS_EQUAL               = #D3D_NAME_DEPTH_LESS_EQUAL  
  

  
  
;- D3D_REGISTER_COMPONENT_TYPE 
  #D3D_REGISTER_COMPONENT_UNKNOWN    = 0
  #D3D_REGISTER_COMPONENT_UINT32     = 1
  #D3D_REGISTER_COMPONENT_SINT32     = 2
  #D3D_REGISTER_COMPONENT_FLOAT32    = 3
  #D3D10_REGISTER_COMPONENT_UNKNOWN  = #D3D_REGISTER_COMPONENT_UNKNOWN
  #D3D10_REGISTER_COMPONENT_UINT32   = #D3D_REGISTER_COMPONENT_UINT32
  #D3D10_REGISTER_COMPONENT_SINT32   = #D3D_REGISTER_COMPONENT_SINT32
  #D3D10_REGISTER_COMPONENT_FLOAT32  = #D3D_REGISTER_COMPONENT_FLOAT32

  
;- D3D_MIN_PRECISION 
  #D3D_MIN_PRECISION_DEFAULT    = 0
  #D3D_MIN_PRECISION_FLOAT_16   = 1
  #D3D_MIN_PRECISION_FLOAT_2_8  = 2
  #D3D_MIN_PRECISION_RESERVED   = 3
  #D3D_MIN_PRECISION_SINT_16    = 4
  #D3D_MIN_PRECISION_UINT_16    = 5
  #D3D_MIN_PRECISION_ANY_16     = $f0
  #D3D_MIN_PRECISION_ANY_10     = $f1


  
  
;- _D3D_CBUFFER_TYPE  
  #D3D_CT_CBUFFER               = 0
  #D3D_CT_TBUFFER               = ( #D3D_CT_CBUFFER + 1 )
  #D3D_CT_INTERFACE_POINTERS    = ( #D3D_CT_TBUFFER + 1 )
  #D3D_CT_RESOURCE_BIND_INFO    = ( #D3D_CT_INTERFACE_POINTERS + 1 )
  #D3D10_CT_CBUFFER             = #D3D_CT_CBUFFER
  #D3D10_CT_TBUFFER             = #D3D_CT_TBUFFER
  #D3D11_CT_CBUFFER             = #D3D_CT_CBUFFER
  #D3D11_CT_TBUFFER             = #D3D_CT_TBUFFER
  #D3D11_CT_INTERFACE_POINTERS  = #D3D_CT_INTERFACE_POINTERS
  #D3D11_CT_RESOURCE_BIND_INFO  = #D3D_CT_RESOURCE_BIND_INFO

  
;- D3D11_RESOURCE_DIMENSION 
  #D3D11_RESOURCE_DIMENSION_UNKNOWN    = 0
  #D3D11_RESOURCE_DIMENSION_BUFFER     = 1
  #D3D11_RESOURCE_DIMENSION_TEXTURE1D  = 2
  #D3D11_RESOURCE_DIMENSION_TEXTURE2D  = 3
  #D3D11_RESOURCE_DIMENSION_TEXTURE3D  = 4

  
  
  
;- D3DX11_IMAGE_FILE_FORMAT 
  #D3DX11_IFF_BMP          = 0
  #D3DX11_IFF_JPG          = 1
  #D3DX11_IFF_PNG          = 3
  #D3DX11_IFF_DDS          = 4
  #D3DX11_IFF_TIFF         = 10
  #D3DX11_IFF_GIF          = 11
  #D3DX11_IFF_WMP          = 12
  #D3DX11_IFF_FORCE_DWORD  = $7fffffff

;- D3D11_COMPARISON_FUNC 
  #D3D11_COMPARISON_NEVER          = 1
  #D3D11_COMPARISON_LESS           = 2
  #D3D11_COMPARISON_EQUAL          = 3
  #D3D11_COMPARISON_LESS_EQUAL     = 4
  #D3D11_COMPARISON_GREATER        = 5
  #D3D11_COMPARISON_NOT_EQUAL      = 6
  #D3D11_COMPARISON_GREATER_EQUAL  = 7
  #D3D11_COMPARISON_ALWAYS         = 8

  
  
;- D3D11_TEXTURE_ADDRESS_MODE 
  #D3D11_TEXTURE_ADDRESS_WRAP         = 1
  #D3D11_TEXTURE_ADDRESS_MIRROR       = 2
  #D3D11_TEXTURE_ADDRESS_CLAMP        = 3
  #D3D11_TEXTURE_ADDRESS_BORDER       = 4
  #D3D11_TEXTURE_ADDRESS_MIRROR_ONCE  = 5

  
;- D3D11_FILTER 
  #D3D11_FILTER_MIN_MAG_MIP_POINT                           = 0
  #D3D11_FILTER_MIN_MAG_POINT_MIP_LINEAR                    = $1
  #D3D11_FILTER_MIN_POINT_MAG_LINEAR_MIP_POINT              = $4
  #D3D11_FILTER_MIN_POINT_MAG_MIP_LINEAR                    = $5
  #D3D11_FILTER_MIN_LINEAR_MAG_MIP_POINT                    = $10
  #D3D11_FILTER_MIN_LINEAR_MAG_POINT_MIP_LINEAR             = $11
  #D3D11_FILTER_MIN_MAG_LINEAR_MIP_POINT                    = $14
  #D3D11_FILTER_MIN_MAG_MIP_LINEAR                          = $15
  #D3D11_FILTER_ANISOTROPIC                                 = $55
  #D3D11_FILTER_COMPARISON_MIN_MAG_MIP_POINT                = $80
  #D3D11_FILTER_COMPARISON_MIN_MAG_POINT_MIP_LINEAR         = $81
  #D3D11_FILTER_COMPARISON_MIN_POINT_MAG_LINEAR_MIP_POINT   = $84
  #D3D11_FILTER_COMPARISON_MIN_POINT_MAG_MIP_LINEAR         = $85
  #D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_MIP_POINT         = $90
  #D3D11_FILTER_COMPARISON_MIN_LINEAR_MAG_POINT_MIP_LINEAR  = $91
  #D3D11_FILTER_COMPARISON_MIN_MAG_LINEAR_MIP_POINT         = $94
  #D3D11_FILTER_COMPARISON_MIN_MAG_MIP_LINEAR               = $95
  #D3D11_FILTER_COMPARISON_ANISOTROPIC                      = $d5
  #D3D11_FILTER_TEXT_1BIT                                   = $80000000

  
;- D3D_SHADER_INPUT_TYPE 
  #D3D_SIT_CBUFFER                          = 0
  #D3D_SIT_TBUFFER                          = ( #D3D_SIT_CBUFFER + 1 )
  #D3D_SIT_TEXTURE                          = ( #D3D_SIT_TBUFFER + 1 )
  #D3D_SIT_SAMPLER                          = ( #D3D_SIT_TEXTURE + 1 )
  #D3D_SIT_UAV_RWTYPED                      = ( #D3D_SIT_SAMPLER + 1 )
  #D3D_SIT_STRUCTURED                       = ( #D3D_SIT_UAV_RWTYPED + 1 )
  #D3D_SIT_UAV_RWSTRUCTURED                 = ( #D3D_SIT_STRUCTURED + 1 )
  #D3D_SIT_BYTEADDRESS                      = ( #D3D_SIT_UAV_RWSTRUCTURED + 1 )
  #D3D_SIT_UAV_RWBYTEADDRESS                = ( #D3D_SIT_BYTEADDRESS + 1 )
  #D3D_SIT_UAV_APPEND_STRUCTURED            = ( #D3D_SIT_UAV_RWBYTEADDRESS + 1 )
  #D3D_SIT_UAV_CONSUME_STRUCTURED           = ( #D3D_SIT_UAV_APPEND_STRUCTURED + 1 )
  #D3D_SIT_UAV_RWSTRUCTURED_WITH_COUNTER    = ( #D3D_SIT_UAV_CONSUME_STRUCTURED + 1 )
  #D3D10_SIT_CBUFFER                        = #D3D_SIT_CBUFFER
  #D3D10_SIT_TBUFFER                        = #D3D_SIT_TBUFFER
  #D3D10_SIT_TEXTURE                        = #D3D_SIT_TEXTURE
  #D3D10_SIT_SAMPLER                        = #D3D_SIT_SAMPLER
  #D3D11_SIT_UAV_RWTYPED                    = #D3D_SIT_UAV_RWTYPED
  #D3D11_SIT_STRUCTURED                     = #D3D_SIT_STRUCTURED
  #D3D11_SIT_UAV_RWSTRUCTURED               = #D3D_SIT_UAV_RWSTRUCTURED
  #D3D11_SIT_BYTEADDRESS                    = #D3D_SIT_BYTEADDRESS
  #D3D11_SIT_UAV_RWBYTEADDRESS              = #D3D_SIT_UAV_RWBYTEADDRESS
  #D3D11_SIT_UAV_APPEND_STRUCTURED          = #D3D_SIT_UAV_APPEND_STRUCTURED
  #D3D11_SIT_UAV_CONSUME_STRUCTURED         = #D3D_SIT_UAV_CONSUME_STRUCTURED
  #D3D11_SIT_UAV_RWSTRUCTURED_WITH_COUNTER  = #D3D_SIT_UAV_RWSTRUCTURED_WITH_COUNTER

  
;- D3D_RESOURCE_RETURN_TYPE 
  #D3D_RETURN_TYPE_UNORM        = 1
  #D3D_RETURN_TYPE_SNORM        = 2
  #D3D_RETURN_TYPE_SINT         = 3
  #D3D_RETURN_TYPE_UINT         = 4
  #D3D_RETURN_TYPE_FLOAT        = 5
  #D3D_RETURN_TYPE_MIXED        = 6
  #D3D_RETURN_TYPE_DOUBLE       = 7
  #D3D_RETURN_TYPE_CONTINUED    = 8
  #D3D10_RETURN_TYPE_UNORM      = #D3D_RETURN_TYPE_UNORM
  #D3D10_RETURN_TYPE_SNORM      = #D3D_RETURN_TYPE_SNORM
  #D3D10_RETURN_TYPE_SINT       = #D3D_RETURN_TYPE_SINT
  #D3D10_RETURN_TYPE_UINT       = #D3D_RETURN_TYPE_UINT
  #D3D10_RETURN_TYPE_FLOAT      = #D3D_RETURN_TYPE_FLOAT
  #D3D10_RETURN_TYPE_MIXED      = #D3D_RETURN_TYPE_MIXED
  #D3D11_RETURN_TYPE_UNORM      = #D3D_RETURN_TYPE_UNORM
  #D3D11_RETURN_TYPE_SNORM      = #D3D_RETURN_TYPE_SNORM
  #D3D11_RETURN_TYPE_SINT       = #D3D_RETURN_TYPE_SINT
  #D3D11_RETURN_TYPE_UINT       = #D3D_RETURN_TYPE_UINT
  #D3D11_RETURN_TYPE_FLOAT      = #D3D_RETURN_TYPE_FLOAT
  #D3D11_RETURN_TYPE_MIXED      = #D3D_RETURN_TYPE_MIXED
  #D3D11_RETURN_TYPE_DOUBLE     = #D3D_RETURN_TYPE_DOUBLE
  #D3D11_RETURN_TYPE_CONTINUED  = #D3D_RETURN_TYPE_CONTINUED

;- D3D_SRV_DIMENSION 
  #D3D_SRV_DIMENSION_UNKNOWN               = 0
  #D3D_SRV_DIMENSION_BUFFER                = 1
  #D3D_SRV_DIMENSION_TEXTURE1D             = 2
  #D3D_SRV_DIMENSION_TEXTURE1DARRAY        = 3
  #D3D_SRV_DIMENSION_TEXTURE2D             = 4
  #D3D_SRV_DIMENSION_TEXTURE2DARRAY        = 5
  #D3D_SRV_DIMENSION_TEXTURE2DMS           = 6
  #D3D_SRV_DIMENSION_TEXTURE2DMSARRAY      = 7
  #D3D_SRV_DIMENSION_TEXTURE3D             = 8
  #D3D_SRV_DIMENSION_TEXTURECUBE           = 9
  #D3D_SRV_DIMENSION_TEXTURECUBEARRAY      = 10
  #D3D_SRV_DIMENSION_BUFFEREX              = 11
  #D3D10_SRV_DIMENSION_UNKNOWN             = #D3D_SRV_DIMENSION_UNKNOWN
  #D3D10_SRV_DIMENSION_BUFFER              = #D3D_SRV_DIMENSION_BUFFER
  #D3D10_SRV_DIMENSION_TEXTURE1D           = #D3D_SRV_DIMENSION_TEXTURE1D
  #D3D10_SRV_DIMENSION_TEXTURE1DARRAY      = #D3D_SRV_DIMENSION_TEXTURE1DARRAY
  #D3D10_SRV_DIMENSION_TEXTURE2D           = #D3D_SRV_DIMENSION_TEXTURE2D
  #D3D10_SRV_DIMENSION_TEXTURE2DARRAY      = #D3D_SRV_DIMENSION_TEXTURE2DARRAY
  #D3D10_SRV_DIMENSION_TEXTURE2DMS         = #D3D_SRV_DIMENSION_TEXTURE2DMS
  #D3D10_SRV_DIMENSION_TEXTURE2DMSARRAY    = #D3D_SRV_DIMENSION_TEXTURE2DMSARRAY
  #D3D10_SRV_DIMENSION_TEXTURE3D           = #D3D_SRV_DIMENSION_TEXTURE3D
  #D3D10_SRV_DIMENSION_TEXTURECUBE         = #D3D_SRV_DIMENSION_TEXTURECUBE
  #D3D10_1_SRV_DIMENSION_UNKNOWN           = #D3D_SRV_DIMENSION_UNKNOWN
  #D3D10_1_SRV_DIMENSION_BUFFER            = #D3D_SRV_DIMENSION_BUFFER
  #D3D10_1_SRV_DIMENSION_TEXTURE1D         = #D3D_SRV_DIMENSION_TEXTURE1D
  #D3D10_1_SRV_DIMENSION_TEXTURE1DARRAY    = #D3D_SRV_DIMENSION_TEXTURE1DARRAY
  #D3D10_1_SRV_DIMENSION_TEXTURE2D         = #D3D_SRV_DIMENSION_TEXTURE2D
  #D3D10_1_SRV_DIMENSION_TEXTURE2DARRAY    = #D3D_SRV_DIMENSION_TEXTURE2DARRAY
  #D3D10_1_SRV_DIMENSION_TEXTURE2DMS       = #D3D_SRV_DIMENSION_TEXTURE2DMS
  #D3D10_1_SRV_DIMENSION_TEXTURE2DMSARRAY  = #D3D_SRV_DIMENSION_TEXTURE2DMSARRAY
  #D3D10_1_SRV_DIMENSION_TEXTURE3D         = #D3D_SRV_DIMENSION_TEXTURE3D
  #D3D10_1_SRV_DIMENSION_TEXTURECUBE       = #D3D_SRV_DIMENSION_TEXTURECUBE
  #D3D10_1_SRV_DIMENSION_TEXTURECUBEARRAY  = #D3D_SRV_DIMENSION_TEXTURECUBEARRAY
  #D3D11_SRV_DIMENSION_UNKNOWN             = #D3D_SRV_DIMENSION_UNKNOWN
  #D3D11_SRV_DIMENSION_BUFFER              = #D3D_SRV_DIMENSION_BUFFER
  #D3D11_SRV_DIMENSION_TEXTURE1D           = #D3D_SRV_DIMENSION_TEXTURE1D
  #D3D11_SRV_DIMENSION_TEXTURE1DARRAY      = #D3D_SRV_DIMENSION_TEXTURE1DARRAY
  #D3D11_SRV_DIMENSION_TEXTURE2D           = #D3D_SRV_DIMENSION_TEXTURE2D
  #D3D11_SRV_DIMENSION_TEXTURE2DARRAY      = #D3D_SRV_DIMENSION_TEXTURE2DARRAY
  #D3D11_SRV_DIMENSION_TEXTURE2DMS         = #D3D_SRV_DIMENSION_TEXTURE2DMS
  #D3D11_SRV_DIMENSION_TEXTURE2DMSARRAY    = #D3D_SRV_DIMENSION_TEXTURE2DMSARRAY
  #D3D11_SRV_DIMENSION_TEXTURE3D           = #D3D_SRV_DIMENSION_TEXTURE3D
  #D3D11_SRV_DIMENSION_TEXTURECUBE         = #D3D_SRV_DIMENSION_TEXTURECUBE
  #D3D11_SRV_DIMENSION_TEXTURECUBEARRAY    = #D3D_SRV_DIMENSION_TEXTURECUBEARRAY
  #D3D11_SRV_DIMENSION_BUFFEREX            = #D3D_SRV_DIMENSION_BUFFEREX
  
  
;- D3D11.h Constants  
  #D3D11_16BIT_INDEX_STRIP_CUT_VALUE = ($fff)
  #D3D11_32BIT_INDEX_STRIP_CUT_VALUE = ($fffffff)
  #D3D11_8BIT_INDEX_STRIP_CUT_VALUE = ($f)
  #D3D11_ARRAY_AXIS_ADDRESS_RANGE_BIT_COUNT = (9)
  #D3D11_CLIP_OR_CULL_DISTANCE_COUNT = (8)
  #D3D11_CLIP_OR_CULL_DISTANCE_ELEMENT_COUNT = (2)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_API_SLOT_COUNT = (14)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_COMPONENTS = (4)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_COMPONENT_BIT_COUNT = (32)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_HW_SLOT_COUNT = (15)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_REGISTER_COMPONENTS = (4)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_REGISTER_COUNT = (15)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_REGISTER_READS_PER_INST = (1)
  #D3D11_COMMONSHADER_CONSTANT_BUFFER_REGISTER_READ_PORTS = (1)
  #D3D11_COMMONSHADER_FLOWCONTROL_NESTING_LIMIT = (64)
  #D3D11_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_COMPONENTS = (4)
  #D3D11_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_COUNT = (1)
  #D3D11_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_READS_PER_INST = (1)
  #D3D11_COMMONSHADER_IMMEDIATE_CONSTANT_BUFFER_REGISTER_READ_PORTS = (1)
  #D3D11_COMMONSHADER_IMMEDIATE_VALUE_COMPONENT_BIT_COUNT = (32)
  #D3D11_COMMONSHADER_INPUT_RESOURCE_REGISTER_COMPONENTS = (1)
  #D3D11_COMMONSHADER_INPUT_RESOURCE_REGISTER_COUNT = (128)
  #D3D11_COMMONSHADER_INPUT_RESOURCE_REGISTER_READS_PER_INST = (1)
  #D3D11_COMMONSHADER_INPUT_RESOURCE_REGISTER_READ_PORTS = (1)
  #D3D11_COMMONSHADER_INPUT_RESOURCE_SLOT_COUNT = (128)
  #D3D11_COMMONSHADER_SAMPLER_REGISTER_COMPONENTS = (1)
  #D3D11_COMMONSHADER_SAMPLER_REGISTER_COUNT = (16)
  #D3D11_COMMONSHADER_SAMPLER_REGISTER_READS_PER_INST = (1)
  #D3D11_COMMONSHADER_SAMPLER_REGISTER_READ_PORTS = (1)
  #D3D11_COMMONSHADER_SAMPLER_SLOT_COUNT = (16)
  #D3D11_COMMONSHADER_SUBROUTINE_NESTING_LIMIT = (32)
  #D3D11_COMMONSHADER_TEMP_REGISTER_COMPONENTS = (4)
  #D3D11_COMMONSHADER_TEMP_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_COMMONSHADER_TEMP_REGISTER_COUNT = (4096)
  #D3D11_COMMONSHADER_TEMP_REGISTER_READS_PER_INST = (3)
  #D3D11_COMMONSHADER_TEMP_REGISTER_READ_PORTS = (3)
  #D3D11_COMMONSHADER_TEXCOORD_RANGE_REDUCTION_MAX = (10)
  #D3D11_COMMONSHADER_TEXCOORD_RANGE_REDUCTION_MIN = (-10)
  #D3D11_COMMONSHADER_TEXEL_OFFSET_MAX_NEGATIVE = (-8)
  #D3D11_COMMONSHADER_TEXEL_OFFSET_MAX_POSITIVE = (7)
  #D3D11_CS_4_X_BUCKET00_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (256)
  #D3D11_CS_4_X_BUCKET00_MAX_NUM_THREADS_PER_GROUP = (64)
  #D3D11_CS_4_X_BUCKET01_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (240)
  #D3D11_CS_4_X_BUCKET01_MAX_NUM_THREADS_PER_GROUP = (68)
  #D3D11_CS_4_X_BUCKET02_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (224)
  #D3D11_CS_4_X_BUCKET02_MAX_NUM_THREADS_PER_GROUP = (72)
  #D3D11_CS_4_X_BUCKET03_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (208)
  #D3D11_CS_4_X_BUCKET03_MAX_NUM_THREADS_PER_GROUP = (76)
  #D3D11_CS_4_X_BUCKET04_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (192)
  #D3D11_CS_4_X_BUCKET04_MAX_NUM_THREADS_PER_GROUP = (84)
  #D3D11_CS_4_X_BUCKET05_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (176)
  #D3D11_CS_4_X_BUCKET05_MAX_NUM_THREADS_PER_GROUP = (92)
  #D3D11_CS_4_X_BUCKET06_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (160)
  #D3D11_CS_4_X_BUCKET06_MAX_NUM_THREADS_PER_GROUP = (100)
  #D3D11_CS_4_X_BUCKET07_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (144)
  #D3D11_CS_4_X_BUCKET07_MAX_NUM_THREADS_PER_GROUP = (112)
  #D3D11_CS_4_X_BUCKET08_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (128)
  #D3D11_CS_4_X_BUCKET08_MAX_NUM_THREADS_PER_GROUP = (128)
  #D3D11_CS_4_X_BUCKET09_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (112)
  #D3D11_CS_4_X_BUCKET09_MAX_NUM_THREADS_PER_GROUP = (144)
  #D3D11_CS_4_X_BUCKET10_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (96)
  #D3D11_CS_4_X_BUCKET10_MAX_NUM_THREADS_PER_GROUP = (168)
  #D3D11_CS_4_X_BUCKET11_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (80)
  #D3D11_CS_4_X_BUCKET11_MAX_NUM_THREADS_PER_GROUP = (204)
  #D3D11_CS_4_X_BUCKET12_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (64)
  #D3D11_CS_4_X_BUCKET12_MAX_NUM_THREADS_PER_GROUP = (256)
  #D3D11_CS_4_X_BUCKET13_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (48)
  #D3D11_CS_4_X_BUCKET13_MAX_NUM_THREADS_PER_GROUP = (340)
  #D3D11_CS_4_X_BUCKET14_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (32)
  #D3D11_CS_4_X_BUCKET14_MAX_NUM_THREADS_PER_GROUP = (512)
  #D3D11_CS_4_X_BUCKET15_MAX_BYTES_TGSM_WRITABLE_PER_THREAD = (16)
  #D3D11_CS_4_X_BUCKET15_MAX_NUM_THREADS_PER_GROUP = (768)
  #D3D11_CS_4_X_DISPATCH_MAX_THREAD_GROUPS_IN_Z_DIMENSION = (1)
  #D3D11_CS_4_X_RAW_UAV_BYTE_ALIGNMENT = (256)
  #D3D11_CS_4_X_THREAD_GROUP_MAX_THREADS_PER_GROUP = (768)
  #D3D11_CS_4_X_THREAD_GROUP_MAX_X = (768)
  #D3D11_CS_4_X_THREAD_GROUP_MAX_Y = (768)
  #D3D11_CS_4_X_UAV_REGISTER_COUNT = (1)
  #D3D11_CS_DISPATCH_MAX_THREAD_GROUPS_PER_DIMENSION = (65535)
  #D3D11_CS_TGSM_REGISTER_COUNT = (8192)
  #D3D11_CS_TGSM_REGISTER_READS_PER_INST = (1)
  #D3D11_CS_TGSM_RESOURCE_REGISTER_COMPONENTS = (1)
  #D3D11_CS_TGSM_RESOURCE_REGISTER_READ_PORTS = (1)
  #D3D11_CS_THREAD_GROUP_MAX_THREADS_PER_GROUP = (1024)
  #D3D11_CS_THREAD_GROUP_MAX_X = (1024)
  #D3D11_CS_THREAD_GROUP_MAX_Y = (1024)
  #D3D11_CS_THREAD_GROUP_MAX_Z = (64)
  #D3D11_CS_THREAD_GROUP_MIN_X = (1)
  #D3D11_CS_THREAD_GROUP_MIN_Y = (1)
  #D3D11_CS_THREAD_GROUP_MIN_Z = (1)
  #D3D11_CS_THREAD_LOCAL_TEMP_REGISTER_POOL = (16384)
  #D3D11_DEFAULT_BLEND_FACTOR_ALPHA = (1.0)
  #D3D11_DEFAULT_BLEND_FACTOR_BLUE = (1.0)
  #D3D11_DEFAULT_BLEND_FACTOR_GREEN = (1.0)
  #D3D11_DEFAULT_BLEND_FACTOR_RED = (1.0)
  #D3D11_DEFAULT_BORDER_COLOR_COMPONENT = (0.0)
  #D3D11_DEFAULT_DEPTH_BIAS = (0)
  #D3D11_DEFAULT_DEPTH_BIAS_CLAMP = (0.0)
  #D3D11_DEFAULT_MAX_ANISOTROPY = (16)
  #D3D11_DEFAULT_MIP_LOD_BIAS = (0.0)
  #D3D11_DEFAULT_RENDER_TARGET_ARRAY_INDEX = (0)
  #D3D11_DEFAULT_SAMPLE_MASK = ($fffffff)
  #D3D11_DEFAULT_SCISSOR_ENDX = (0)
  #D3D11_DEFAULT_SCISSOR_ENDY = (0)
  #D3D11_DEFAULT_SCISSOR_STARTX = (0)
  #D3D11_DEFAULT_SCISSOR_STARTY = (0)
  #D3D11_DEFAULT_SLOPE_SCALED_DEPTH_BIAS = (0.0)
  #D3D11_DEFAULT_STENCIL_READ_MASK = ($f)
  #D3D11_DEFAULT_STENCIL_REFERENCE = (0)
  #D3D11_DEFAULT_STENCIL_WRITE_MASK = ($f)
  #D3D11_DEFAULT_VIEWPORT_AND_SCISSORRECT_INDEX = (0)
  #D3D11_DEFAULT_VIEWPORT_HEIGHT = (0)
  #D3D11_DEFAULT_VIEWPORT_MAX_DEPTH = (0.0)
  #D3D11_DEFAULT_VIEWPORT_MIN_DEPTH = (0.0)
  #D3D11_DEFAULT_VIEWPORT_TOPLEFTX = (0)
  #D3D11_DEFAULT_VIEWPORT_TOPLEFTY = (0)
  #D3D11_DEFAULT_VIEWPORT_WIDTH = (0)
  #D3D11_DS_INPUT_CONTROL_POINTS_MAX_TOTAL_SCALARS = (3968)
  #D3D11_DS_INPUT_CONTROL_POINT_REGISTER_COMPONENTS = (4)
  #D3D11_DS_INPUT_CONTROL_POINT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_DS_INPUT_CONTROL_POINT_REGISTER_COUNT = (32)
  #D3D11_DS_INPUT_CONTROL_POINT_REGISTER_READS_PER_INST = (2)
  #D3D11_DS_INPUT_CONTROL_POINT_REGISTER_READ_PORTS = (1)
  #D3D11_DS_INPUT_DOMAIN_POINT_REGISTER_COMPONENTS = (3)
  #D3D11_DS_INPUT_DOMAIN_POINT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_DS_INPUT_DOMAIN_POINT_REGISTER_COUNT = (1)
  #D3D11_DS_INPUT_DOMAIN_POINT_REGISTER_READS_PER_INST = (2)
  #D3D11_DS_INPUT_DOMAIN_POINT_REGISTER_READ_PORTS = (1)
  #D3D11_DS_INPUT_PATCH_CONSTANT_REGISTER_COMPONENTS = (4)
  #D3D11_DS_INPUT_PATCH_CONSTANT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_DS_INPUT_PATCH_CONSTANT_REGISTER_COUNT = (32)
  #D3D11_DS_INPUT_PATCH_CONSTANT_REGISTER_READS_PER_INST = (2)
  #D3D11_DS_INPUT_PATCH_CONSTANT_REGISTER_READ_PORTS = (1)
  #D3D11_DS_OUTPUT_REGISTER_COMPONENTS = (4)
  #D3D11_DS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_DS_OUTPUT_REGISTER_COUNT = (32)
  #D3D11_FLOAT16_FUSED_TOLERANCE_IN_ULP = (0.6)
  #D3D11_FLOAT32_MAX = (3.402823466e+38)
  #D3D11_FLOAT32_TO_INTEGER_TOLERANCE_IN_ULP = (0.6)
  #D3D11_FLOAT_TO_SRGB_EXPONENT_DENOMINATOR = (2.4)
  #D3D11_FLOAT_TO_SRGB_EXPONENT_NUMERATOR = (1.0)
  #D3D11_FLOAT_TO_SRGB_OFFSET = (0.055)
  #D3D11_FLOAT_TO_SRGB_SCALE_1 = (12.92)
  #D3D11_FLOAT_TO_SRGB_SCALE_2 = (1.055)
  #D3D11_FLOAT_TO_SRGB_THRESHOLD = (0.0031308)
  #D3D11_FTOI_INSTRUCTION_MAX_INPUT = (2147483647.999)
  #D3D11_FTOI_INSTRUCTION_MIN_INPUT = (-2147483648.999)
  #D3D11_FTOU_INSTRUCTION_MAX_INPUT = (4294967295.999)
  #D3D11_FTOU_INSTRUCTION_MIN_INPUT = (0.0)
  #D3D11_GS_INPUT_INSTANCE_ID_READS_PER_INST = (2)
  #D3D11_GS_INPUT_INSTANCE_ID_READ_PORTS = (1)
  #D3D11_GS_INPUT_INSTANCE_ID_REGISTER_COMPONENTS = (1)
  #D3D11_GS_INPUT_INSTANCE_ID_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_GS_INPUT_INSTANCE_ID_REGISTER_COUNT = (1)
  #D3D11_GS_INPUT_PRIM_CONST_REGISTER_COMPONENTS = (1)
  #D3D11_GS_INPUT_PRIM_CONST_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_GS_INPUT_PRIM_CONST_REGISTER_COUNT = (1)
  #D3D11_GS_INPUT_PRIM_CONST_REGISTER_READS_PER_INST = (2)
  #D3D11_GS_INPUT_PRIM_CONST_REGISTER_READ_PORTS = (1)
  #D3D11_GS_INPUT_REGISTER_COMPONENTS = (4)
  #D3D11_GS_INPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_GS_INPUT_REGISTER_COUNT = (32)
  #D3D11_GS_INPUT_REGISTER_READS_PER_INST = (2)
  #D3D11_GS_INPUT_REGISTER_READ_PORTS = (1)
  #D3D11_GS_INPUT_REGISTER_VERTICES = (32)
  #D3D11_GS_MAX_INSTANCE_COUNT = (32)
  #D3D11_GS_MAX_OUTPUT_VERTEX_COUNT_ACROSS_INSTANCES = (1024)
  #D3D11_GS_OUTPUT_ELEMENTS = (32)
  #D3D11_GS_OUTPUT_REGISTER_COMPONENTS = (4)
  #D3D11_GS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_GS_OUTPUT_REGISTER_COUNT = (32)
  #D3D11_HS_CONTROL_POINT_PHASE_INPUT_REGISTER_COUNT = (32)
  #D3D11_HS_CONTROL_POINT_PHASE_OUTPUT_REGISTER_COUNT = (32)
  #D3D11_HS_CONTROL_POINT_REGISTER_COMPONENTS = (4)
  #D3D11_HS_CONTROL_POINT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_CONTROL_POINT_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_CONTROL_POINT_REGISTER_READ_PORTS = (1)
  #D3D11_HS_FORK_PHASE_INSTANCE_COUNT_UPPER_BOUND = ($fffffff)
  #D3D11_HS_INPUT_FORK_INSTANCE_ID_REGISTER_COMPONENTS = (1)
  #D3D11_HS_INPUT_FORK_INSTANCE_ID_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_INPUT_FORK_INSTANCE_ID_REGISTER_COUNT = (1)
  #D3D11_HS_INPUT_FORK_INSTANCE_ID_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_INPUT_FORK_INSTANCE_ID_REGISTER_READ_PORTS = (1)
  #D3D11_HS_INPUT_JOIN_INSTANCE_ID_REGISTER_COMPONENTS = (1)
  #D3D11_HS_INPUT_JOIN_INSTANCE_ID_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_INPUT_JOIN_INSTANCE_ID_REGISTER_COUNT = (1)
  #D3D11_HS_INPUT_JOIN_INSTANCE_ID_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_INPUT_JOIN_INSTANCE_ID_REGISTER_READ_PORTS = (1)
  #D3D11_HS_INPUT_PRIMITIVE_ID_REGISTER_COMPONENTS = (1)
  #D3D11_HS_INPUT_PRIMITIVE_ID_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_INPUT_PRIMITIVE_ID_REGISTER_COUNT = (1)
  #D3D11_HS_INPUT_PRIMITIVE_ID_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_INPUT_PRIMITIVE_ID_REGISTER_READ_PORTS = (1)
  #D3D11_HS_JOIN_PHASE_INSTANCE_COUNT_UPPER_BOUND = ($fffffff)
  #D3D11_HS_MAXTESSFACTOR_LOWER_BOUND = (1.0)
  #D3D11_HS_MAXTESSFACTOR_UPPER_BOUND = (64.0)
  #D3D11_HS_OUTPUT_CONTROL_POINTS_MAX_TOTAL_SCALARS = (3968)
  #D3D11_HS_OUTPUT_CONTROL_POINT_ID_REGISTER_COMPONENTS = (1)
  #D3D11_HS_OUTPUT_CONTROL_POINT_ID_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_OUTPUT_CONTROL_POINT_ID_REGISTER_COUNT = (1)
  #D3D11_HS_OUTPUT_CONTROL_POINT_ID_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_OUTPUT_CONTROL_POINT_ID_REGISTER_READ_PORTS = (1)
  #D3D11_HS_OUTPUT_PATCH_CONSTANT_REGISTER_COMPONENTS = (4)
  #D3D11_HS_OUTPUT_PATCH_CONSTANT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_HS_OUTPUT_PATCH_CONSTANT_REGISTER_COUNT = (32)
  #D3D11_HS_OUTPUT_PATCH_CONSTANT_REGISTER_READS_PER_INST = (2)
  #D3D11_HS_OUTPUT_PATCH_CONSTANT_REGISTER_READ_PORTS = (1)
  #D3D11_IA_DEFAULT_INDEX_BUFFER_OFFSET_IN_BYTES = (0)
  #D3D11_IA_DEFAULT_PRIMITIVE_TOPOLOGY = (0)
  #D3D11_IA_DEFAULT_VERTEX_BUFFER_OFFSET_IN_BYTES = (0)
  #D3D11_IA_INDEX_INPUT_RESOURCE_SLOT_COUNT = (1)
  #D3D11_IA_INSTANCE_ID_BIT_COUNT = (32)
  #D3D11_IA_INTEGER_ARITHMETIC_BIT_COUNT = (32)
  #D3D11_IA_PATCH_MAX_CONTROL_POINT_COUNT = (32)
  #D3D11_IA_PRIMITIVE_ID_BIT_COUNT = (32)
  #D3D11_IA_VERTEX_ID_BIT_COUNT = (32)
  #D3D11_IA_VERTEX_INPUT_RESOURCE_SLOT_COUNT = (32)
  #D3D11_IA_VERTEX_INPUT_STRUCTURE_ELEMENTS_COMPONENTS = (128)
  #D3D11_IA_VERTEX_INPUT_STRUCTURE_ELEMENT_COUNT = (32)
  #D3D11_INTEGER_DIVIDE_BY_ZERO_QUOTIENT = ($fffffff)
  #D3D11_INTEGER_DIVIDE_BY_ZERO_REMAINDER = ($fffffff)
  #D3D11_KEEP_RENDER_TARGETS_AND_DEPTH_STENCIL = ($fffffff)
  #D3D11_KEEP_UNORDERED_ACCESS_VIEWS = ($fffffff)
  #D3D11_LINEAR_GAMMA = (1.0)
  #D3D11_MAJOR_VERSION = (11)
  #D3D11_MAX_BORDER_COLOR_COMPONENT = (1.0)
  #D3D11_MAX_DEPTH = (1.0)
  #D3D11_MAX_MAXANISOTROPY = (16)
  #D3D11_MAX_MULTISAMPLE_SAMPLE_COUNT = (32)
  #D3D11_MAX_POSITION_VALUE = (3.402823466e+34)
  #D3D11_MAX_TEXTURE_DIMENSION_2_TO_EXP = (17)
  #D3D11_MINOR_VERSION = (0)
  #D3D11_MIN_BORDER_COLOR_COMPONENT = (0.0)
  #D3D11_MIN_DEPTH = (0.0)
  #D3D11_MIN_MAXANISOTROPY = (0)
  #D3D11_MIP_LOD_BIAS_MAX = (15.99)
  #D3D11_MIP_LOD_BIAS_MIN = (-16.0)
  #D3D11_MIP_LOD_FRACTIONAL_BIT_COUNT = (8)
  #D3D11_MIP_LOD_RANGE_BIT_COUNT = (8)
  #D3D11_MULTISAMPLE_ANTIALIAS_LINE_WIDTH = (1.4)
  #D3D11_NONSAMPLE_FETCH_OUT_OF_RANGE_ACCESS_RESULT = (0)
  #D3D11_PIXEL_ADDRESS_RANGE_BIT_COUNT = (15)
  #D3D11_PRE_SCISSOR_PIXEL_ADDRESS_RANGE_BIT_COUNT = (16)
  #D3D11_PS_CS_UAV_REGISTER_COMPONENTS = (1)
  #D3D11_PS_CS_UAV_REGISTER_COUNT = (8)
  #D3D11_PS_CS_UAV_REGISTER_READS_PER_INST = (1)
  #D3D11_PS_CS_UAV_REGISTER_READ_PORTS = (1)
  #D3D11_PS_FRONTFACING_DEFAULT_VALUE = ($fffffff)
  #D3D11_PS_FRONTFACING_FALSE_VALUE = (0)
  #D3D11_PS_FRONTFACING_TRUE_VALUE = ($fffffff)
  #D3D11_PS_INPUT_REGISTER_COMPONENTS = (4)
  #D3D11_PS_INPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_PS_INPUT_REGISTER_COUNT = (32)
  #D3D11_PS_INPUT_REGISTER_READS_PER_INST = (2)
  #D3D11_PS_INPUT_REGISTER_READ_PORTS = (1)
  #D3D11_PS_LEGACY_PIXEL_CENTER_FRACTIONAL_COMPONENT = (0.0)
  #D3D11_PS_OUTPUT_DEPTH_REGISTER_COMPONENTS = (1)
  #D3D11_PS_OUTPUT_DEPTH_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_PS_OUTPUT_DEPTH_REGISTER_COUNT = (1)
  #D3D11_PS_OUTPUT_MASK_REGISTER_COMPONENTS = (1)
  #D3D11_PS_OUTPUT_MASK_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_PS_OUTPUT_MASK_REGISTER_COUNT = (1)
  #D3D11_PS_OUTPUT_REGISTER_COMPONENTS = (4)
  #D3D11_PS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_PS_OUTPUT_REGISTER_COUNT = (8)
  #D3D11_PS_PIXEL_CENTER_FRACTIONAL_COMPONENT = (0.5)
  #D3D11_RAW_UAV_SRV_BYTE_ALIGNMENT = (16)
  #D3D11_REQ_BLEND_OBJECT_COUNT_PER_DEVICE = (4096)
  #D3D11_REQ_BUFFER_RESOURCE_TEXEL_COUNT_2_TO_EXP = (27)
  #D3D11_REQ_CONSTANT_BUFFER_ELEMENT_COUNT = (4096)
  #D3D11_REQ_DEPTH_STENCIL_OBJECT_COUNT_PER_DEVICE = (4096)
  #D3D11_REQ_DRAWINDEXED_INDEX_COUNT_2_TO_EXP = (32)
  #D3D11_REQ_DRAW_VERTEX_COUNT_2_TO_EXP = (32)
  #D3D11_REQ_FILTERING_HW_ADDRESSABLE_RESOURCE_DIMENSION = (16384)
  #D3D11_REQ_GS_INVOCATION_32BIT_OUTPUT_COMPONENT_LIMIT = (1024)
  #D3D11_REQ_IMMEDIATE_CONSTANT_BUFFER_ELEMENT_COUNT = (4096)
  #D3D11_REQ_MAXANISOTROPY = (16)
  #D3D11_REQ_MIP_LEVELS = (15)
  #D3D11_REQ_MULTI_ELEMENT_STRUCTURE_SIZE_IN_BYTES = (2048)
  #D3D11_REQ_RASTERIZER_OBJECT_COUNT_PER_DEVICE = (4096)
  #D3D11_REQ_RENDER_TO_BUFFER_WINDOW_WIDTH = (16384)
  #D3D11_REQ_RESOURCE_SIZE_IN_MEGABYTES_EXPRESSION_A_TERM = (128)
  #D3D11_REQ_RESOURCE_SIZE_IN_MEGABYTES_EXPRESSION_B_TERM = (0.25)
  #D3D11_REQ_RESOURCE_VIEW_COUNT_PER_DEVICE_2_TO_EXP = (20)
  #D3D11_REQ_SAMPLER_OBJECT_COUNT_PER_DEVICE = (4096)
  #D3D11_REQ_TEXTURE1D_ARRAY_AXIS_DIMENSION = (2048)
  #D3D11_REQ_TEXTURE1D_U_DIMENSION = (16384)
  #D3D11_REQ_TEXTURE2D_ARRAY_AXIS_DIMENSION = (2048)
  #D3D11_REQ_TEXTURE2D_U_OR_V_DIMENSION = (16384)
  #D3D11_REQ_TEXTURE3D_U_V_OR_W_DIMENSION = (2048)
  #D3D11_REQ_TEXTURECUBE_DIMENSION = (16384)
  #D3D11_RESINFO_INSTRUCTION_MISSING_COMPONENT_RETVAL = (0)
  #D3D11_SHADER_MAJOR_VERSION = (5)
  #D3D11_SHADER_MAX_INSTANCES = (65535)
  #D3D11_SHADER_MAX_INTERFACES = (253)
  #D3D11_SHADER_MAX_INTERFACE_CALL_SITES = (4096)
  #D3D11_SHADER_MAX_TYPES = (65535)
  #D3D11_SHADER_MINOR_VERSION = (0)
  #D3D11_SHIFT_INSTRUCTION_PAD_VALUE = (0)
  #D3D11_SHIFT_INSTRUCTION_SHIFT_VALUE_BIT_COUNT = (5)
  #D3D11_SIMULTANEOUS_RENDER_TARGET_COUNT = (8)
  #D3D11_SO_BUFFER_MAX_STRIDE_IN_BYTES = (2048)
  #D3D11_SO_BUFFER_MAX_WRITE_WINDOW_IN_BYTES = (512)
  #D3D11_SO_BUFFER_SLOT_COUNT = (4)
  #D3D11_SO_DDI_REGISTER_INDEX_DENOTING_GAP = ($fffffff)
  #D3D11_SO_NO_RASTERIZED_STREAM = ($fffffff)
  #D3D11_SO_OUTPUT_COMPONENT_COUNT = (128)
  #D3D11_SO_STREAM_COUNT = (4)
  #D3D11_SPEC_DATE_DAY = (04)
  #D3D11_SPEC_DATE_MONTH = (06)
  #D3D11_SPEC_DATE_YEAR = (2009)
  #D3D11_SPEC_VERSION = (1.0)
  #D3D11_SRGB_GAMMA = (2.2)
  #D3D11_SRGB_TO_FLOAT_DENOMINATOR_1 = (12.92)
  #D3D11_SRGB_TO_FLOAT_DENOMINATOR_2 = (1.055)
  #D3D11_SRGB_TO_FLOAT_EXPONENT = (2.4)
  #D3D11_SRGB_TO_FLOAT_OFFSET = (0.055)
  #D3D11_SRGB_TO_FLOAT_THRESHOLD = (0.04045)
  #D3D11_SRGB_TO_FLOAT_TOLERANCE_IN_ULP = (0.5)
  #D3D11_STANDARD_COMPONENT_BIT_COUNT = (32)
  #D3D11_STANDARD_COMPONENT_BIT_COUNT_DOUBLED = (64)
  #D3D11_STANDARD_MAXIMUM_ELEMENT_ALIGNMENT_BYTE_MULTIPLE = (4)
  #D3D11_STANDARD_PIXEL_COMPONENT_COUNT = (128)
  #D3D11_STANDARD_PIXEL_ELEMENT_COUNT = (32)
  #D3D11_STANDARD_VECTOR_SIZE = (4)
  #D3D11_STANDARD_VERTEX_ELEMENT_COUNT = (32)
  #D3D11_STANDARD_VERTEX_TOTAL_COMPONENT_COUNT = (64)
  #D3D11_SUBPIXEL_FRACTIONAL_BIT_COUNT = (8)
  #D3D11_SUBTEXEL_FRACTIONAL_BIT_COUNT = (8)
  #D3D11_TESSELLATOR_MAX_EVEN_TESSELLATION_FACTOR = (64)
  #D3D11_TESSELLATOR_MAX_ISOLINE_DENSITY_TESSELLATION_FACTOR = (64)
  #D3D11_TESSELLATOR_MAX_ODD_TESSELLATION_FACTOR = (63)
  #D3D11_TESSELLATOR_MAX_TESSELLATION_FACTOR = (64)
  #D3D11_TESSELLATOR_MIN_EVEN_TESSELLATION_FACTOR = (2)
  #D3D11_TESSELLATOR_MIN_ISOLINE_DENSITY_TESSELLATION_FACTOR = (1)
  #D3D11_TESSELLATOR_MIN_ODD_TESSELLATION_FACTOR = (1)
  #D3D11_TEXEL_ADDRESS_RANGE_BIT_COUNT = (16)
  #D3D11_UNBOUND_MEMORY_ACCESS_RESULT = (0)
  #D3D11_VIEWPORT_AND_SCISSORRECT_MAX_INDEX = (15)
  #D3D11_VIEWPORT_AND_SCISSORRECT_OBJECT_COUNT_PER_PIPELINE = (16)
  #D3D11_VIEWPORT_BOUNDS_MAX = (32767)
  #D3D11_VIEWPORT_BOUNDS_MIN = (-32768)
  #D3D11_VS_INPUT_REGISTER_COMPONENTS = (4)
  #D3D11_VS_INPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_VS_INPUT_REGISTER_COUNT = (32)
  #D3D11_VS_INPUT_REGISTER_READS_PER_INST = (2)
  #D3D11_VS_INPUT_REGISTER_READ_PORTS = (1)
  #D3D11_VS_OUTPUT_REGISTER_COMPONENTS = (4)
  #D3D11_VS_OUTPUT_REGISTER_COMPONENT_BIT_COUNT = (32)
  #D3D11_VS_OUTPUT_REGISTER_COUNT = (32)
  #D3D11_WHQL_CONTEXT_COUNT_FOR_RESOURCE_LIMIT = (10)
  #D3D11_WHQL_DRAWINDEXED_INDEX_COUNT_2_TO_EXP = (25)
  #D3D11_WHQL_DRAW_VERTEX_COUNT_2_TO_EXP = (25)
  
  
  
;- DXGI_ENUM_MODES 
  #DXGI_ENUM_MODES_INTERLACED = 1
  #DXGI_ENUM_MODES_SCALING    = 2
  
  
;- D3DDEVTYPE 
  #D3DDEVTYPE_HAL          = 1
  #D3DDEVTYPE_NULLREF      = 4
  #D3DDEVTYPE_REF          = 2
  #D3DDEVTYPE_SW           = 3
  #D3DDEVTYPE_FORCE_DWORD  = $ffffffff

  
;- D2D1_ALPHA_MODE
  #D2D1_ALPHA_MODE_UNKNOWN        = 0
  #D2D1_ALPHA_MODE_PREMULTIPLIED  = 1
  #D2D1_ALPHA_MODE_STRAIGHT       = 2
  #D2D1_ALPHA_MODE_IGNORE         = 3
;  
  
;-  D3D11_BLEND 
  #D3D11_BLEND_ZERO               = 1
  #D3D11_BLEND_ONE                = 2
  #D3D11_BLEND_SRC_COLOR          = 3
  #D3D11_BLEND_INV_SRC_COLOR      = 4
  #D3D11_BLEND_SRC_ALPHA          = 5
  #D3D11_BLEND_INV_SRC_ALPHA      = 6
  #D3D11_BLEND_DEST_ALPHA         = 7
  #D3D11_BLEND_INV_DEST_ALPHA     = 8
  #D3D11_BLEND_DEST_COLOR         = 9
  #D3D11_BLEND_INV_DEST_COLOR     = 10
  #D3D11_BLEND_SRC_ALPHA_SAT      = 11
  #D3D11_BLEND_BLEND_FACTOR       = 14
  #D3D11_BLEND_INV_BLEND_FACTOR   = 15
  #D3D11_BLEND_SRC1_COLOR         = 16
  #D3D11_BLEND_INV_SRC1_COLOR     = 17
  #D3D11_BLEND_SRC1_ALPHA         = 18
  #D3D11_BLEND_INV_SRC1_ALPHA     = 19 

; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 1386
; FirstLine = 1329
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0