﻿;/////////////////////////////////////////////////////////////;
;                                                             ;
;                 SimpleDX11 Camera Interface                 ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 


;-//    Public structures    //

;-//    Public Interfaces    //
Interface Camera
  SetPosition(x.f, y.f, z.f)
  GetPosition()  
  SetRotation(x.f, y.f, z.f)
  GetRotation()
  SetTarget(x.f, y.f, z.f)
  GetTarget()
  GetViewMatrix()
  Render()
  Release()
EndInterface


;- Constructor
Declare New_Camera(*SD3D.Screen3D)
; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 29
; EnableUnicode
; EnableXP