;/////////////////////////////////////////////////////////////;
;                                                             ;
;                  SimpleDX11 Mesh Interface                  ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 


;-//    Public structures    //


;-//    Public Interfaces    //
Interface Mesh
  GetTopology()
  SetTopology(Topology.l)
  GetStride()
  SetStride(Stride.l)
  GetVBuffer()
  GetIBuffer()
  CreateBuffer(*VertexArray, *IndexArray)
  Render()
  Release()    
EndInterface


;-//    Constructor    //
Declare New_Mesh(*SD3D.Screen3D, Flags.l = #Null)
; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 24
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0