;/////////////////////////////////////////////////////////////;
;                                                             ;
;                 SimpleDX11 Light Interface                 ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 


;-//    Public structures    //
  Enumeration 1
    #VertexShader
    #PixelShader
    #Lighting
    #Textured
  EndEnumeration
  
;-//    Public Interfaces    //
Interface Light
  SetSpecularColor(*Color.D3DXCOLOR)
  SetSpecularPower(Power.f)
  SetAmbientColor(*Color.D3DXCOLOR)
  SetDiffuseColor(*Color.D3DXCOLOR)
  SetDirection(x.f, y.f, z.f)
  GetSpecularColor()
  GetSpecularPower()
  GetAmbientColor()
  GetDiffuseColor()
  GetDirection()  
  Release()
EndInterface


;- Constructor
Declare New_Light()
; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 23
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0