;/////////////////////////////////////////////////////////////;
;                                                             ;
;                 SimpleDX11 Model Interface                  ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 

 


;-//    Public constants    //
  #SDX_Vertex_Normals     = %00000000000000000000000000000001
  #SDX_Vertex_Colors      = %00000000000000000000000000000010
  #SDX_Vertex_UVMap       = %00000000000000000000000000000100
  
;-//    Public structures    //

;-//    Public Interfaces    //
Interface Model 
  GetPrimitive()
  GetMesh()
  LoadTexture(File.s)
  AddTriangle(TriangleSize.f, *Color.D3DXCOLOR = #Null)
  AddRectangle(RectangleSize.f, *Color.D3DXCOLOR = #Null)
  AddCube(CubeSize.f, *Color.D3DXCOLOR = #Null)
  LoadObjModel(File.s, ObjectName.s = "")
  SetModel()
  Render()
  Release()
EndInterface


Declare New_Model(*SD3D.Screen3D, Flags.l = #Null)


; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 29
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0