;/////////////////////////////////////////////////////////////;
;                                                             ;
;                SimpleDX11 Primitive Interface               ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 


  
;-//    Public structures    //

;-//    Public Interfaces    //
Interface Primitive
  AddVertex(x.f, y.f, z.f)
  AddVerticesArray(*Vertices, VertexCount.l, vOffset.l = #Null)
  ResetVertexList()
  SelectVertex(vID.l = #Null, UVMapID.l = #Null)
  NextVertex()
  DeleteVertex(vID.l = #Null)
  ClearVertexList()
  SetNormal(x.f, y.f, z.f)
  SetColor(*Color.D3DXCOLOR = #Null)
  AddUVMap()
  SetUV(u.f, v.f) 
  VertexListSize()
  VertexSize()
  GetVerticesArray()
  AddIndex(Index.l)
  AddIndicesArray(*Indices, IndexCount.l = #Null)  
  GetIndexCount()
  ResetIndex()
  SelectIndex(iId.l)
  NextIndex()
  DeleteIndex()
  ClearIndexList()
  SetIndex(NewIndex.l)
  GetIndex()
  GetIndexArray()
  Release()
  SetTopology(Topology.l)
  GetTopology()
  GetStride()
EndInterface


;-//    Constructor    //
Declare New_Primitive(Flags.l = #Null)
; IDE Options = PureBasic 5.20 beta 10 LTS (Windows - x64)
; CursorPosition = 11
; EnableXP
; EnableCompileCount = 0
; EnableBuildCount = 0