﻿;/////////////////////////////////////////////////////////////;
;                                                             ;
;                 SimpleDX11 Direct3D Interface               ;
;                                                             ;
;                                                             ;
;                   (c) 2013 SimpleDX Team                    ;
;                                                             ;
;                         License: MIT                        ;
;                                                             ;
;/////////////////////////////////////////////////////////////; 


;-//    Public structures    //

;-//    Public Interfaces    //
Interface Screen3D
  GetSwapChain()
  GetDevice()
  GetDeviceContext()
  GetRenderTargetView()
  GetDepthStencilView()
  GetDepthStencilBuffer()
  GetDepthStencilState()
  GetRasterState()
  GetWorldMatrix()
  GetProjectionMatrix()
  GetOrthoMatrix()
  GetViewMatrix()
  TurnOnAlphaBlending()
  TurnOffAlphaBlending()
  Start3D()
  Stop3D()
  GetAlpha(a.l)
  GetBlue(b.l)
  GetGreen(g.l)
  GetRed(r.l)
  GetZBufferStatus()
  Release()
EndInterface


;- Constructor
Declare New_Screen3D()



; IDE Options = PureBasic 5.20 beta 14 LTS (Windows - x64)
; CursorPosition = 29
; EnableUnicode
; EnableXP